//: C05:CountedClass.cpp
// Z knihy "Myslíme v jazyce C++, část 2" od Bruce Eckela a Chucka Allisona.
// (c) 1995-2004 MindView, Inc. Všechna práva vyhrazena.
// Přečtěte si podmínky používání zdrojových kódů umístěné v souboru 
// 'Licence.txt' dodávaném spolu s balíčkem kódu dostupným na www.MindView.net.
// POčítání objektů pomocí statických členů.
#include <iostream>
using namespace std;

class PocitanaTrida {
  static int pocet;
public:
  PocitanaTrida() { ++pocet; }
  PocitanaTrida(const PocitanaTrida&) { ++pocet; }
  ~PocitanaTrida() { --pocet; }
  static int zjistiPocet() { return pocet; }
};

int PocitanaTrida::pocet = 0;

int main() {
  PocitanaTrida a;
  cout << PocitanaTrida::zjistiPocet() << endl;   // 1
  PocitanaTrida b;
  cout << PocitanaTrida::zjistiPocet() << endl;   // 2
  { // libovolný rozsah platnosti:
    PocitanaTrida c(b);
    cout << PocitanaTrida::zjistiPocet() << endl; // 3
    a = c;
    cout << PocitanaTrida::zjistiPocet() << endl; // 3
  }
  cout << PocitanaTrida::zjistiPocet() << endl;   // 2
} ///:~
